Subject: Re: [PATCH] ipv6: release referenct of ip6_null_entry's dst entry in __ip6_del_rt

From: Gao feng <[email-masked]>
Date: Mon, 24 Sep 2012 12:32:14 +0800

于 2012年09月22日 01:16, David Miller 写道:
> From: Gao feng <[email-masked]>
> Date: Thu, 20 Sep 2012 13:25:34 +0800
> 
>> as we hold dst_entry before we call __ip6_del_rt,
>> so we should alse call dst_release not only return
>> -ENOENT when the rt6_info is ip6_null_entry.
>>
>> and we already hold the dst entry, so I think it's
>> safe to call dst_release out of the write-read lock.
>>
>> Signed-off-by: Gao feng <[email-masked]>
> 
> I cannot find a code path where we can actually end up
> with an ip6_null_entry here and I'd much rather declare
> this condition as a bug.
> 
> Patrick McHardy added this check back in 2006:
> 
> 	commit 6c813a7297e3af4cd7c3458e09e9ee3d161c6830
> 	Author: Patrick McHardy <[email-masked]>
> 	Date:   Sun Aug 6 22:22:47 2006 -0700
> 
> 	    [IPV6]: Fix crash in ip6_del_rt
> 
> But the ipv6 code has changed substantially since then.

ip -6 route del ::/0 will end up with an ip6_null_entry.
so I think this checking and this patch is needed .